<?php

	include_once("authorize.php");	
  checkUser();   
  include_once("ini.php");
  readIni();	
	
  $days = preg_replace("/[^0-9]/i",'', $_POST["days"]); 
  $path = preg_replace("/[^_A-Za-z0-9-\.%\/]/i",'', $_POST["path"]);   
  $path = preg_replace("/\.\.\//",'', $path); 	
  if(intval($dispdays) == 0) $dispdays=7;
  $pageonly = $_POST["pageonly"];
  $thispage = __FILE__;
  
  function isPage($url)
  {
    $ext = strrchr($url, ".");
    return isValid($ext);
  }   
  
?>	
<html>
<head>
<link type="text/css" href="script.css" rel="stylesheet">
<meta name="robots" content="none">
<style type="text/css">
.dir
{
  border:1px solid gray;
}
</style>
</head>
<body>
<div id="content">
<h2>Site Crawler</h2>
<p>A basic model for various checking scripts</p>
<br>
<form method="post" name="crawler">
  Within : <input type="text" name="days" id="days" maxlength="4" size="4" value="<?php echo $dispdays; ?>"> days
  <span style="margin-left:16px">No limit:</span>
  <input type="checkbox" name="cb" id="cb" onclick="nolimit()" >
  <span style="margin-left:16px">Pages only:</span>
  <input type="checkbox" name="pageonly" id="pageonly" checked
  onchange="element.value=element.checked" >
  <span style="margin-left:16px">Starting directory:</span> 
  <input type="text" name="path" maxlength="80" size="30" value="/" > 
  <input type="submit" value="Start Crawl" >
</form>

<br>
    
<?php    

    $dispflag = 0;                        
    $dircount = 0;                      
    $date = time();                      
    define('ABSPATH', $_SERVER['DOCUMENT_ROOT']);
    $path = ABSPATH.$path;   
    $dirlist[0] = $path;
    $rootlen = strlen(ABSPATH);
    $directory = "";
   
    $dispflag = 86400 * $days;
    if($dispflag > 0)
    {
        $fcounter = 0;    
        print "<br><table><tr><td width=\"450\"><b><u>Filename</u></b></td><td><b><u>Last modified date</u></b></td></tr>\n";
        $diff = $date - $dispflag;
        $i = 0;        
        while($i <= $dircount)
        {
            $currdir = $dirlist[$i];
            $directory = "<td colspan='2' class='dir'><b>".substr($currdir, $rootlen)."</b></td><tr></tr>\n";
            $dircontent = opendir( $dirlist[$i] );
            while($fname = readdir( $dircontent))   // read each file in dir
            {
                if($fname == '.') continue;
                if($fname == '..') continue;

                $fullpath = $currdir . $fname;
                if(is_dir($fullpath))
                {
                        $dircount++;
                        $dirlist[$dircount] = $fullpath . "/";
                }
                else
                {
                        if($pageonly && !isPage($fname)) continue;
                        $file_date = filemtime($fullpath);                             
                        if ($file_date > $diff)
                        {
                            if ($directory != "")
                            {
                                print $directory;
                                $directory = "";
                            };                         
                            $relname = substr($fullpath, $rootlen);
                            print "<tr><td>".$relname. "</td>";
                            print "<td>".date("M d, Y  -  H:i:s", $file_date)."</td></tr>\n";
                            $fcounter ++;
                        }
                }
            }
            closedir ( $dircontent );
            $i++;    
        }
        print "</table>\n";   
        print "<br />Within <strong>$days</strong> days, <strong>$fcounter</strong> files changed.<br>"; 
 
    }

      
?>


</div>
</body>
</html> 
