<?php

    /*
     Bioloide Gallery Generator
     (c)2009-2011 Scriptol.com
    */

    include_once("authorize.php");	
    checkUser();   

    $display = 0;                        
    $fcount = 0;                          
    $dcount = 0;                      
    $date = time();                      
    $one_day = 86400;
    $extlist = array();
    
    $extensions = $_POST["extensions"];
    $imageonly = $_POST["imageonly"];
    $recurse = $_POST["recurse"];
    
    $days = preg_replace("/[^0-9]/i",'', $_POST["days"]); 
    $path = preg_replace("/[^_A-Za-z0-9-\.%\/]/i",'', $_POST["path"]);   
    $path = preg_replace("/\.\.\//",'', $path);   

    define('ABSPATH', $_SERVER['DOCUMENT_ROOT']);
    $path = ABSPATH.$path;   
    $dirlist[0] = $path;
    $rootlen = strlen(ABSPATH);
    
    $protocol = $_SERVER['SERVER_PROTOCOL'];
    $protocol = preg_split("/[^a-z|A-Z]/i", $protocol);
    $protocol=strtolower($protocol[0]);
    $domain = $_SERVER['HTTP_HOST'];
    $root = $protocol."://".$domain;
    
    if($imageonly)
    {
      $extlist = explode(',', $extensions);
    }

    function isImage($url)
    {
      global $extensions;
      global $extlist;
      
      $ext = strrchr($url, ".");
      if($ext == false || $ext == "") return false;
      $ext = substr($ext, 1);
      return (in_array($ext, $extlist, true));
    }     
   
    
?>    
    
<html>
<head>
<title>Simple Crawler - Model</title>
<link type="text/css" href="script.css" rel="stylesheet">
<meta name="robots" content="none">
<script type = "text/javascript">

function cbChange(element)
{
  if(element.checked == false)
    element.value = "";
  else
    element.value = element.src;
}

</script>
</head>
<body>
<div id="content">
<h2>Scriptol Gallery Generator</h2>

<form method="post" action="">

Source of images 
<input type="text" name="path" maxlength="80" size="30" value="/images/" > ( / at end) 
<span style="margin-left:16px">Recurse</span>
<input type="checkbox" id="recurse" name="recurse" value="false" onchange="this.value=this.checked">
<span style="margin-left:16px">Since </span>
<input type="text" name="days" maxlength="4" size="3" value="9999"> days

<br>
Image extensions 
<input type="text" name="extensions" id="extensions" maxlength="80" size="30" value="gif,jpg,png,jpeg" >
<span style="margin-left:16px">Only images</span>
<input type="checkbox" id="imageonly" name="imageonly" value="true" onchange="this.value=this.checked" checked>
 
<input style="margin:8px" type="submit" value="Get images">
</form>

 
<form method="post" action="galcode.php"> 
  
<?php  
    $directory = "none";
    $display = $one_day * $days;
    
    if ( $display > 0 )
   {
        if(intval($day) != 9999)
          print "<br /> Last <strong>" . ($display/$one_day) ."</strong> days: <br /><br />";   
   
        print "<table><tr><td width='32'><u>Check</u></td><td><b><u>Filename</u></b></td><td><b><u>Last modified date</u></b></td></tr>";
        $diff = $date - $display;
        $i = 0;
        while($i <= $dcount)
        {
            $currdir = $dirlist[$i];
            $directory = "<tr><td>dir</td><td><b>".substr($currdir, $rootlen)."</b></td><td></td></tr>";
            $dircontent = opendir($currdir);
            while ($fname = readdir($dircontent))
            {
                if($fname == '.' ) continue; 
                if($fname == '..') continue;

                $fullpath = $currdir . $fname;
                if (is_dir($fullpath))
                {
                    if(!$recurse) continue;
                    $dcount++;
                    $dirlist[$dcount] = "$fullpath/";
                }
                else
                {
                    if($imageonly && !isImage($fullpath)) continue;
                    if(filemtime($fullpath) > $diff)
                    {
                       if ($directory != "")
                       {
                           print $directory;
                           $directory = "";
                       };       

                       $relname = substr($fullpath, $rootlen);                       
                       $cb = "cb".strval($fcount);
                       $webname = $root.$relname;
                       print "<tr>";
                       print "<td><input type='checkbox' onchange='cbChange(this)' name='$cb' id='$cb' src='$webname' ></td>";
                       print "<td>$relname</td>";
                       $lastmod = filemtime($fullpath);
                       $fdate = date("M d, Y  -  H:i:s", $lastmod);
                       print  "<td>$fdate</td></tr>" ;
                       $fcount++;
                    }
               }
             }
            closedir($dircontent);
            $i++;    
        }
        print "</table><br>$fcount images. <br><hr>";    

        print " Title:<input type='text' id='title' name='title' maxlength='80' size='30' value='' >";
        print " File to create:<input type='text' id='target' name='target' maxlength='80' size='30' value='/' >";
        print "<span style='margin-left:8px'>Columns:</span><input type='text' id='columns' name='columns' maxlength='4' size='4' value='1' >";
        print "<input  style='margin-left:8px' type='submit' value='Generate Gallery'>";
        print "<hr>";

    }


        
?>


</form>

</div>
</body>
</html> 
